(function(){"use strict";try{if(typeof document!="undefined"){var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;margin-top:0;margin-bottom:0;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
var ir = Object.defineProperty;
var sr = (r, e, t) => e in r ? ir(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t;
var P = (r, e, t) => (sr(r, typeof e != "symbol" ? e + "" : e, t), t), Re = (r, e, t) => {
  if (!e.has(r))
    throw TypeError("Cannot " + t);
};
var W = (r, e, t) => (Re(r, e, "read from private field"), t ? t.call(r) : e.get(r)), K = (r, e, t) => {
  if (e.has(r))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(r) : e.set(r, t);
}, ke = (r, e, t, n) => (Re(r, e, "write to private field"), n ? n.call(r, t) : e.set(r, t), t);
var le = (r, e, t) => (Re(r, e, "access private method"), t);
import Pe, { useContext as or, Children as lr, isValidElement as st, useEffect as U, useState as re, useRef as Te, useLayoutEffect as ur, useCallback as X, memo as mt, useMemo as Oe, forwardRef as cr, createRef as ot } from "react";
class ue {
  constructor(e, t, n, i) {
    this.data = e, this.prev = t, this.next = n, this.list = i;
  }
  get index() {
    if (!!this.list)
      return this.list.findIndex((e) => e === this.data);
  }
  insertBefore(e) {
    return this.list !== null ? this.list.insertBefore(this, e) : new M(e, this.data);
  }
  insertAfter(e) {
    return this.list !== null ? this.list.insertAfter(this, e) : new M(this.data, e);
  }
  remove() {
    if (this.list === null)
      throw new ReferenceError("Node does not belong to any list");
    return this.list.removeNode(this);
  }
}
class M {
  constructor(...e) {
    P(this, "head");
    P(this, "tail");
    P(this, "size");
    this.head = null, this.tail = null, this.size = 0;
    for (let t = 0; t < arguments.length; t++)
      this.append(arguments[t]);
  }
  get length() {
    return this.size;
  }
  static from(e) {
    return new M(...e);
  }
  get(e) {
    const t = this.getNode(e);
    return t !== void 0 ? t.data : void 0;
  }
  getNode(e) {
    if (this.head === null || e < 0 || e >= this.length)
      return;
    const t = e < this.length / 2, n = t ? e : this.length - e - 1, i = t ? "next" : "prev";
    let s = t ? this.head : this.tail;
    for (let l = 0; l < n; l++)
      s = s[i];
    return s;
  }
  findNodeIndex(e) {
    let t = 0, n = this.head;
    for (; n; ) {
      if (e(n.data, t, this))
        return {
          index: t,
          node: n
        };
      n = n.next, t += 1;
    }
  }
  findNode(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node : void 0;
  }
  find(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node.data : void 0;
  }
  findIndex(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.index : -1;
  }
  append(...e) {
    for (const t of e) {
      const n = new ue(t, this.tail, null, this);
      this.head === null && (this.head = n), this.tail !== null && (this.tail.next = n), this.tail = n, this.size += 1;
    }
    return this;
  }
  prepend(...e) {
    const t = Array.from(e).reverse();
    for (const n of t) {
      const i = new ue(n, null, this.head, this);
      this.tail === null && (this.tail = i), this.head !== null && (this.head.prev = i), this.head = i, this.size += 1;
    }
    return this;
  }
  insertAt(e, t) {
    if (this.head === null)
      return this.append(t);
    if (e <= 0)
      return this.prepend(t);
    let n = this.head, i = 0;
    for (; i < e - 1 && n.next !== null; )
      i += 1, n = n.next;
    return n.insertAfter(t), this;
  }
  removeNode(e) {
    if (e.list !== this)
      throw new ReferenceError("Node does not belong to this list");
    return e.prev !== null && (e.prev.next = e.next), e.next !== null && (e.next.prev = e.prev), this.head === e && (this.head = e.next), this.tail === e && (this.tail = e.prev), this.size -= 1, e.next = null, e.prev = null, e.list = null, e;
  }
  removeAt(e) {
    const t = this.getNode(e);
    return t !== void 0 ? this.removeNode(t) : void 0;
  }
  insertBefore(e, t) {
    const n = new ue(t, e.prev, e, this);
    return e.prev === null && (this.head = n), e.prev !== null && (e.prev.next = n), e.prev = n, this.size += 1, this;
  }
  sort(e) {
    if (this.head === null || this.tail === null)
      return this;
    if (this.length < 2)
      return this;
    const t = (n, i) => {
      if (n === i)
        return;
      const s = i.data;
      let l = n, u = n;
      for (; l && l !== i; ) {
        if (e(l.data, s)) {
          if (l !== u) {
            const h = u.data;
            u.data = l.data, l.data = h;
          }
          u = u.next;
        }
        l = l.next;
      }
      i.data = u.data, u.data = s, n.next !== i.prev && (u.prev && u !== n && t(n, u.prev), u.next && u !== i && t(u.next, i));
    };
    return t(this.head, this.tail), this;
  }
  insertAfter(e, t) {
    const n = new ue(t, e, e.next, this);
    return e.next === null && (this.tail = n), e.next !== null && (e.next.prev = n), e.next = n, this.size += 1, this;
  }
  shift() {
    return this.removeFromAnyEnd(this.head);
  }
  pop() {
    return this.removeFromAnyEnd(this.tail);
  }
  merge(e) {
    this.tail !== null && (this.tail.next = e.head), e.head !== null && (e.head.prev = this.tail), this.head = this.head || e.head, this.tail = e.tail || this.tail, this.size += e.size, e.size = this.size, e.head = this.head, e.tail = this.tail;
  }
  clear() {
    return this.head = null, this.tail = null, this.size = 0, this;
  }
  slice(e, t) {
    const n = new M();
    let i = t;
    if (this.head === null || this.tail === null)
      return n;
    (i === void 0 || i < e) && (i = this.length);
    let s = this.getNode(e);
    for (let l = 0; l < i - e && s !== null && s !== void 0; l++)
      n.append(s.data), s = s.next;
    return n;
  }
  reverse() {
    let e = this.head;
    for (; e; ) {
      const n = e.next;
      e.next = e.prev, e.prev = n, e = e.prev;
    }
    const t = this.tail;
    return this.tail = this.head, this.head = t, this;
  }
  forEach(e, t = !1) {
    let n = t ? this.length - 1 : 0, i = t ? this.tail : this.head;
    const s = t ? -1 : 1, l = t ? "prev" : "next";
    for (; i; )
      e(i.data, n, this), i = i[l], n += s;
  }
  map(e, t = !1) {
    const n = new M();
    return this.forEach((i, s) => n.append(e(i, s, this)), t), n;
  }
  filter(e, t = !1) {
    const n = new M();
    return this.forEach((i, s) => {
      e(i, s, this) && n.append(i);
    }, t), n;
  }
  reduce(e, t, n = !1) {
    let i = n ? this.length - 1 : 0;
    const s = n ? -1 : 1, l = n ? "prev" : "next";
    let u = n ? this.tail : this.head, f;
    if (t !== void 0)
      f = t;
    else if (u)
      f = u.data, u = u[l];
    else
      throw new TypeError("Reduce of empty LinkedList with no initial value");
    for (; u; )
      f = e(f, u.data, i, this), i += s, u = u[l];
    return f;
  }
  toArray() {
    return [...this];
  }
  toString(e = " ") {
    return this.reduce((t, n) => `${t}${e}${n}`);
  }
  *[Symbol.iterator]() {
    let e = this.head;
    for (; e !== null; )
      yield e.data, e = e.next;
  }
  removeFromAnyEnd(e) {
    return e !== null ? this.removeNode(e).data : void 0;
  }
}
var $ = /* @__PURE__ */ ((r) => (r.UP = "ArrowUp", r.DOWN = "ArrowDown", r.LEFT = "ArrowLeft", r.RIGHT = "ArrowRight", r.END = "End", r.HOME = "Home", r.PAGE_DOWN = "PageDown", r.PAGE_UP = "PageUp", r.ENTER = "Enter", r.TAB = "Tab", r.SPACE = " ", r.BACKSPACE = "Backspace", r.DELETE = "Delete", r.COMMA = ",", r.ESC = "Escape", r))($ || {}), L = /* @__PURE__ */ ((r) => (r.LABEL = "__label__", r.VALUE = "__value__", r))(L || {});
const lt = "mk-input", ut = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: [],
  index: 0
}, fr = ["onFocus", "onBlur", "onKeyDown", "onClick"], dr = new RegExp(/^\w*/), hr = M.from([]);
class vr {
  constructor(e, t) {
    P(this, "done", !1);
    this.raw = e, this.uniRegExp = t;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let e = this.uniRegExp.exec(this.raw);
    if (e === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [t, n, i] = this.extractPieces(e);
    return this.raw = i, { done: !1, value: [t, n] };
  }
  extractPieces(e) {
    const t = this.extractMark(e), n = t.input.substring(0, t.index), i = t.input.substring(t.index + t.annotation.length);
    return [n, t, i];
  }
  extractMark(e) {
    let t = e[0], n = 0, i = e[1], s = e[2];
    for (; !(i || s); )
      n++, i = e[2 * n + 1], s = e[2 * n + 2];
    let l = e.index, u = e.input;
    return { annotation: t, label: i, value: s, input: u, index: l, childIndex: n };
  }
}
class he {
  constructor(e) {
    P(this, "markups");
    P(this, "uniRegExp");
    this.markups = e, this.uniRegExp = new RegExp(this.regExps.map((t) => t.source).join("|"));
  }
  get regExps() {
    return this.markups.map(pr);
  }
  static split(e, t) {
    const n = t.map((i) => i.markup);
    return () => new he(n).split(e);
  }
  split(e) {
    return this.iterateMatches(e);
  }
  iterateMatches(e) {
    const t = [];
    for (let [n, i] of new vr(e, this.uniRegExp))
      t.push(n), i !== null && t.push(gr(i, this.markups[i.childIndex]));
    return t;
  }
}
const yt = Object.assign, pr = (r) => {
  var s, l;
  const e = ce(r), t = ce((s = r[r.indexOf(L.LABEL) + L.LABEL.length]) != null ? s : ""), n = ce((l = r[r.indexOf(L.VALUE) + L.VALUE.length]) != null ? l : ""), i = e.replace(L.LABEL, `([^${t}]+?)`).replace(L.VALUE, `([^${n}]+?)`);
  return new RegExp(i);
}, gr = (r, e) => r.annotation !== Ne(e, r.label, r.value) ? { ...r, label: r.value, value: r.label } : r, ce = (r) => r.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function Ne(r, e, t) {
  let n = r.replace(L.LABEL, e);
  return t ? n.replace(L.VALUE, t) : n;
}
function en(r, e, ...t) {
  return t.length ? new he(t).split(r).reduce((i, s) => i += ve(s) ? e(s) : s, "") : r;
}
function ct(r, e) {
  let t = "";
  for (let n of r)
    t += xt(n) ? Ne(e[n.childIndex].markup, n.label, n.value) : n.label;
  return t;
}
const ft = (r, e = 0) => {
  let t = 3735928559 ^ e, n = 1103547991 ^ e;
  for (let i = 0, s; i < r.length; i++)
    s = r.charCodeAt(i), t = Math.imul(t ^ s, 2654435761), n = Math.imul(n ^ s, 1597334677);
  return t = Math.imul(t ^ t >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(t ^ t >>> 13, 3266489909), 4294967296 * (2097151 & n) + (t >>> 0);
}, ve = (r) => typeof r == "object", xt = (r) => r !== null && typeof r == "object" && "annotation" in r;
function mr(r) {
  if (!(r !== null && typeof r == "object" && "annotation" in r))
    throw new Error("Value is not annotated mark!");
}
const dt = (r) => typeof r == "string" && r.startsWith("on"), yr = (r) => st(r) ? !0 : st(r == null ? void 0 : r[0]);
function Et(r) {
  if (yr(r))
    return lr.map(r, (t, n) => e(t.props, n));
  if (r != null && r.length)
    return r.map(e);
  return [ut];
  function e(t, n) {
    return yt({}, ut, t, { index: n });
  }
}
const bt = (r) => {
  const e = Pe.createContext(void 0);
  e.displayName = r;
  const t = i(e), n = e.Provider;
  return [t, n];
  function i(s) {
    return () => {
      const l = or(s);
      if (l)
        return l;
      throw new Error(`The context ${s.displayName} didn't found!`);
    };
  }
}, [R, xr] = bt("StoreProvider"), [wt, Er] = bt("NodeProvider");
function br(r, e, t, n) {
  return r.slice(0, t) + e + r.slice(t + n.length);
}
function wr(r, e) {
  const t = ve(r) ? r.label + r.value : r;
  let n = 0, i = ft(t, n);
  for (; e != null && e.has(i); )
    i = ft(t, n++);
  return e == null || e.add(i), i;
}
const Cr = (r) => r && "$$typeof" in r && r.$$typeof === Symbol.for("react.forward_ref");
var w = /* @__PURE__ */ ((r) => (r[r.Change = 0] = "Change", r[r.Delete = 1] = "Delete", r[r.CheckTrigger = 2] = "CheckTrigger", r[r.ClearTrigger = 3] = "ClearTrigger", r[r.Trigger = 4] = "Trigger", r[r.Select = 5] = "Select", r[r.State = 6] = "State", r))(w || {});
function A(r, e, t, n) {
  const {
    bus: i
  } = n != null ? n : R();
  U(() => i.listen(r, e), t);
}
function Rr(r, e) {
  if (Object.is(r, e))
    return !0;
  if (typeof r != "object" || r === null || typeof e != "object" || e === null)
    return !1;
  const t = Object.keys(r);
  if (t.length !== Object.keys(e).length)
    return !1;
  for (let n = 0; n < t.length; n++)
    if (!Object.prototype.hasOwnProperty.call(e, t[n]) || !Object.is(r[t[n]], e[t[n]]))
      return !1;
  return !0;
}
const I = (r, e) => {
  const t = R(), [n, i] = re(() => r(t.state));
  return A(w.State, (s) => {
    i((l) => {
      const u = r(s);
      return e && Rr(l, u) ? l : u;
    });
  }, []), n;
};
var Ae = { exports: {} }, ee = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ht;
function kr() {
  if (ht)
    return ee;
  ht = 1;
  var r = Pe, e = Symbol.for("react.element"), t = Symbol.for("react.fragment"), n = Object.prototype.hasOwnProperty, i = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, s = { key: !0, ref: !0, __self: !0, __source: !0 };
  function l(u, f, h) {
    var g, x = {}, C = null, k = null;
    h !== void 0 && (C = "" + h), f.key !== void 0 && (C = "" + f.key), f.ref !== void 0 && (k = f.ref);
    for (g in f)
      n.call(f, g) && !s.hasOwnProperty(g) && (x[g] = f[g]);
    if (u && u.defaultProps)
      for (g in f = u.defaultProps, f)
        x[g] === void 0 && (x[g] = f[g]);
    return { $$typeof: e, type: u, key: C, ref: k, props: x, _owner: i.current };
  }
  return ee.Fragment = t, ee.jsx = l, ee.jsxs = l, ee;
}
var te = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var vt;
function Sr() {
  return vt || (vt = 1, process.env.NODE_ENV !== "production" && function() {
    var r = Pe, e = Symbol.for("react.element"), t = Symbol.for("react.portal"), n = Symbol.for("react.fragment"), i = Symbol.for("react.strict_mode"), s = Symbol.for("react.profiler"), l = Symbol.for("react.provider"), u = Symbol.for("react.context"), f = Symbol.for("react.forward_ref"), h = Symbol.for("react.suspense"), g = Symbol.for("react.suspense_list"), x = Symbol.for("react.memo"), C = Symbol.for("react.lazy"), k = Symbol.for("react.offscreen"), O = Symbol.iterator, pe = "@@iterator";
    function kt(a) {
      if (a === null || typeof a != "object")
        return null;
      var o = O && a[O] || a[pe];
      return typeof o == "function" ? o : null;
    }
    var G = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function S(a) {
      {
        for (var o = arguments.length, c = new Array(o > 1 ? o - 1 : 0), d = 1; d < o; d++)
          c[d - 1] = arguments[d];
        St("error", a, c);
      }
    }
    function St(a, o, c) {
      {
        var d = G.ReactDebugCurrentFrame, m = d.getStackAddendum();
        m !== "" && (o += "%s", c = c.concat([m]));
        var y = c.map(function(p) {
          return String(p);
        });
        y.unshift("Warning: " + o), Function.prototype.apply.call(console[a], console, y);
      }
    }
    var _t = !1, Pt = !1, Tt = !1, Ot = !1, Nt = !1, Fe;
    Fe = Symbol.for("react.module.reference");
    function At(a) {
      return !!(typeof a == "string" || typeof a == "function" || a === n || a === s || Nt || a === i || a === h || a === g || Ot || a === k || _t || Pt || Tt || typeof a == "object" && a !== null && (a.$$typeof === C || a.$$typeof === x || a.$$typeof === l || a.$$typeof === u || a.$$typeof === f || a.$$typeof === Fe || a.getModuleId !== void 0));
    }
    function Dt(a, o, c) {
      var d = a.displayName;
      if (d)
        return d;
      var m = o.displayName || o.name || "";
      return m !== "" ? c + "(" + m + ")" : c;
    }
    function Le(a) {
      return a.displayName || "Context";
    }
    function j(a) {
      if (a == null)
        return null;
      if (typeof a.tag == "number" && S("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof a == "function")
        return a.displayName || a.name || null;
      if (typeof a == "string")
        return a;
      switch (a) {
        case n:
          return "Fragment";
        case t:
          return "Portal";
        case s:
          return "Profiler";
        case i:
          return "StrictMode";
        case h:
          return "Suspense";
        case g:
          return "SuspenseList";
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case u:
            var o = a;
            return Le(o) + ".Consumer";
          case l:
            var c = a;
            return Le(c._context) + ".Provider";
          case f:
            return Dt(a, a.render, "ForwardRef");
          case x:
            var d = a.displayName || null;
            return d !== null ? d : j(a.type) || "Memo";
          case C: {
            var m = a, y = m._payload, p = m._init;
            try {
              return j(p(y));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var B = Object.assign, Z = 0, Me, $e, We, Ve, Ue, Be, ze;
    function Ge() {
    }
    Ge.__reactDisabledLog = !0;
    function It() {
      {
        if (Z === 0) {
          Me = console.log, $e = console.info, We = console.warn, Ve = console.error, Ue = console.group, Be = console.groupCollapsed, ze = console.groupEnd;
          var a = {
            configurable: !0,
            enumerable: !0,
            value: Ge,
            writable: !0
          };
          Object.defineProperties(console, {
            info: a,
            log: a,
            warn: a,
            error: a,
            group: a,
            groupCollapsed: a,
            groupEnd: a
          });
        }
        Z++;
      }
    }
    function jt() {
      {
        if (Z--, Z === 0) {
          var a = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: B({}, a, {
              value: Me
            }),
            info: B({}, a, {
              value: $e
            }),
            warn: B({}, a, {
              value: We
            }),
            error: B({}, a, {
              value: Ve
            }),
            group: B({}, a, {
              value: Ue
            }),
            groupCollapsed: B({}, a, {
              value: Be
            }),
            groupEnd: B({}, a, {
              value: ze
            })
          });
        }
        Z < 0 && S("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var ge = G.ReactCurrentDispatcher, me;
    function ne(a, o, c) {
      {
        if (me === void 0)
          try {
            throw Error();
          } catch (m) {
            var d = m.stack.trim().match(/\n( *(at )?)/);
            me = d && d[1] || "";
          }
        return `
` + me + a;
      }
    }
    var ye = !1, ae;
    {
      var Ft = typeof WeakMap == "function" ? WeakMap : Map;
      ae = new Ft();
    }
    function He(a, o) {
      if (!a || ye)
        return "";
      {
        var c = ae.get(a);
        if (c !== void 0)
          return c;
      }
      var d;
      ye = !0;
      var m = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var y;
      y = ge.current, ge.current = null, It();
      try {
        if (o) {
          var p = function() {
            throw Error();
          };
          if (Object.defineProperty(p.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(p, []);
            } catch (F) {
              d = F;
            }
            Reflect.construct(a, [], p);
          } else {
            try {
              p.call();
            } catch (F) {
              d = F;
            }
            a.call(p.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (F) {
            d = F;
          }
          a();
        }
      } catch (F) {
        if (F && d && typeof F.stack == "string") {
          for (var v = F.stack.split(`
`), _ = d.stack.split(`
`), E = v.length - 1, b = _.length - 1; E >= 1 && b >= 0 && v[E] !== _[b]; )
            b--;
          for (; E >= 1 && b >= 0; E--, b--)
            if (v[E] !== _[b]) {
              if (E !== 1 || b !== 1)
                do
                  if (E--, b--, b < 0 || v[E] !== _[b]) {
                    var N = `
` + v[E].replace(" at new ", " at ");
                    return a.displayName && N.includes("<anonymous>") && (N = N.replace("<anonymous>", a.displayName)), typeof a == "function" && ae.set(a, N), N;
                  }
                while (E >= 1 && b >= 0);
              break;
            }
        }
      } finally {
        ye = !1, ge.current = y, jt(), Error.prepareStackTrace = m;
      }
      var q = a ? a.displayName || a.name : "", it = q ? ne(q) : "";
      return typeof a == "function" && ae.set(a, it), it;
    }
    function Lt(a, o, c) {
      return He(a, !1);
    }
    function Mt(a) {
      var o = a.prototype;
      return !!(o && o.isReactComponent);
    }
    function ie(a, o, c) {
      if (a == null)
        return "";
      if (typeof a == "function")
        return He(a, Mt(a));
      if (typeof a == "string")
        return ne(a);
      switch (a) {
        case h:
          return ne("Suspense");
        case g:
          return ne("SuspenseList");
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case f:
            return Lt(a.render);
          case x:
            return ie(a.type, o, c);
          case C: {
            var d = a, m = d._payload, y = d._init;
            try {
              return ie(y(m), o, c);
            } catch {
            }
          }
        }
      return "";
    }
    var se = Object.prototype.hasOwnProperty, qe = {}, Ye = G.ReactDebugCurrentFrame;
    function oe(a) {
      if (a) {
        var o = a._owner, c = ie(a.type, a._source, o ? o.type : null);
        Ye.setExtraStackFrame(c);
      } else
        Ye.setExtraStackFrame(null);
    }
    function $t(a, o, c, d, m) {
      {
        var y = Function.call.bind(se);
        for (var p in a)
          if (y(a, p)) {
            var v = void 0;
            try {
              if (typeof a[p] != "function") {
                var _ = Error((d || "React class") + ": " + c + " type `" + p + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof a[p] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw _.name = "Invariant Violation", _;
              }
              v = a[p](o, p, d, c, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (E) {
              v = E;
            }
            v && !(v instanceof Error) && (oe(m), S("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", d || "React class", c, p, typeof v), oe(null)), v instanceof Error && !(v.message in qe) && (qe[v.message] = !0, oe(m), S("Failed %s type: %s", c, v.message), oe(null));
          }
      }
    }
    var Wt = Array.isArray;
    function xe(a) {
      return Wt(a);
    }
    function Vt(a) {
      {
        var o = typeof Symbol == "function" && Symbol.toStringTag, c = o && a[Symbol.toStringTag] || a.constructor.name || "Object";
        return c;
      }
    }
    function Ut(a) {
      try {
        return Je(a), !1;
      } catch {
        return !0;
      }
    }
    function Je(a) {
      return "" + a;
    }
    function Xe(a) {
      if (Ut(a))
        return S("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", Vt(a)), Je(a);
    }
    var Q = G.ReactCurrentOwner, Bt = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Ze, Qe, Ee;
    Ee = {};
    function zt(a) {
      if (se.call(a, "ref")) {
        var o = Object.getOwnPropertyDescriptor(a, "ref").get;
        if (o && o.isReactWarning)
          return !1;
      }
      return a.ref !== void 0;
    }
    function Gt(a) {
      if (se.call(a, "key")) {
        var o = Object.getOwnPropertyDescriptor(a, "key").get;
        if (o && o.isReactWarning)
          return !1;
      }
      return a.key !== void 0;
    }
    function Ht(a, o) {
      if (typeof a.ref == "string" && Q.current && o && Q.current.stateNode !== o) {
        var c = j(Q.current.type);
        Ee[c] || (S('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', j(Q.current.type), a.ref), Ee[c] = !0);
      }
    }
    function qt(a, o) {
      {
        var c = function() {
          Ze || (Ze = !0, S("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
        };
        c.isReactWarning = !0, Object.defineProperty(a, "key", {
          get: c,
          configurable: !0
        });
      }
    }
    function Yt(a, o) {
      {
        var c = function() {
          Qe || (Qe = !0, S("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
        };
        c.isReactWarning = !0, Object.defineProperty(a, "ref", {
          get: c,
          configurable: !0
        });
      }
    }
    var Jt = function(a, o, c, d, m, y, p) {
      var v = {
        $$typeof: e,
        type: a,
        key: o,
        ref: c,
        props: p,
        _owner: y
      };
      return v._store = {}, Object.defineProperty(v._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(v, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: d
      }), Object.defineProperty(v, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: m
      }), Object.freeze && (Object.freeze(v.props), Object.freeze(v)), v;
    };
    function Xt(a, o, c, d, m) {
      {
        var y, p = {}, v = null, _ = null;
        c !== void 0 && (Xe(c), v = "" + c), Gt(o) && (Xe(o.key), v = "" + o.key), zt(o) && (_ = o.ref, Ht(o, m));
        for (y in o)
          se.call(o, y) && !Bt.hasOwnProperty(y) && (p[y] = o[y]);
        if (a && a.defaultProps) {
          var E = a.defaultProps;
          for (y in E)
            p[y] === void 0 && (p[y] = E[y]);
        }
        if (v || _) {
          var b = typeof a == "function" ? a.displayName || a.name || "Unknown" : a;
          v && qt(p, b), _ && Yt(p, b);
        }
        return Jt(a, v, _, m, d, Q.current, p);
      }
    }
    var be = G.ReactCurrentOwner, Ke = G.ReactDebugCurrentFrame;
    function H(a) {
      if (a) {
        var o = a._owner, c = ie(a.type, a._source, o ? o.type : null);
        Ke.setExtraStackFrame(c);
      } else
        Ke.setExtraStackFrame(null);
    }
    var we;
    we = !1;
    function Ce(a) {
      return typeof a == "object" && a !== null && a.$$typeof === e;
    }
    function et() {
      {
        if (be.current) {
          var a = j(be.current.type);
          if (a)
            return `

Check the render method of \`` + a + "`.";
        }
        return "";
      }
    }
    function Zt(a) {
      {
        if (a !== void 0) {
          var o = a.fileName.replace(/^.*[\\\/]/, ""), c = a.lineNumber;
          return `

Check your code at ` + o + ":" + c + ".";
        }
        return "";
      }
    }
    var tt = {};
    function Qt(a) {
      {
        var o = et();
        if (!o) {
          var c = typeof a == "string" ? a : a.displayName || a.name;
          c && (o = `

Check the top-level render call using <` + c + ">.");
        }
        return o;
      }
    }
    function rt(a, o) {
      {
        if (!a._store || a._store.validated || a.key != null)
          return;
        a._store.validated = !0;
        var c = Qt(o);
        if (tt[c])
          return;
        tt[c] = !0;
        var d = "";
        a && a._owner && a._owner !== be.current && (d = " It was passed a child from " + j(a._owner.type) + "."), H(a), S('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', c, d), H(null);
      }
    }
    function nt(a, o) {
      {
        if (typeof a != "object")
          return;
        if (xe(a))
          for (var c = 0; c < a.length; c++) {
            var d = a[c];
            Ce(d) && rt(d, o);
          }
        else if (Ce(a))
          a._store && (a._store.validated = !0);
        else if (a) {
          var m = kt(a);
          if (typeof m == "function" && m !== a.entries)
            for (var y = m.call(a), p; !(p = y.next()).done; )
              Ce(p.value) && rt(p.value, o);
        }
      }
    }
    function Kt(a) {
      {
        var o = a.type;
        if (o == null || typeof o == "string")
          return;
        var c;
        if (typeof o == "function")
          c = o.propTypes;
        else if (typeof o == "object" && (o.$$typeof === f || o.$$typeof === x))
          c = o.propTypes;
        else
          return;
        if (c) {
          var d = j(o);
          $t(c, a.props, "prop", d, a);
        } else if (o.PropTypes !== void 0 && !we) {
          we = !0;
          var m = j(o);
          S("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", m || "Unknown");
        }
        typeof o.getDefaultProps == "function" && !o.getDefaultProps.isReactClassApproved && S("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function er(a) {
      {
        for (var o = Object.keys(a.props), c = 0; c < o.length; c++) {
          var d = o[c];
          if (d !== "children" && d !== "key") {
            H(a), S("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", d), H(null);
            break;
          }
        }
        a.ref !== null && (H(a), S("Invalid attribute `ref` supplied to `React.Fragment`."), H(null));
      }
    }
    function at(a, o, c, d, m, y) {
      {
        var p = At(a);
        if (!p) {
          var v = "";
          (a === void 0 || typeof a == "object" && a !== null && Object.keys(a).length === 0) && (v += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var _ = Zt(m);
          _ ? v += _ : v += et();
          var E;
          a === null ? E = "null" : xe(a) ? E = "array" : a !== void 0 && a.$$typeof === e ? (E = "<" + (j(a.type) || "Unknown") + " />", v = " Did you accidentally export a JSX literal instead of a component?") : E = typeof a, S("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", E, v);
        }
        var b = Xt(a, o, c, m, y);
        if (b == null)
          return b;
        if (p) {
          var N = o.children;
          if (N !== void 0)
            if (d)
              if (xe(N)) {
                for (var q = 0; q < N.length; q++)
                  nt(N[q], a);
                Object.freeze && Object.freeze(N);
              } else
                S("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              nt(N, a);
        }
        return a === n ? er(b) : Kt(b), b;
      }
    }
    function tr(a, o, c) {
      return at(a, o, c, !0);
    }
    function rr(a, o, c) {
      return at(a, o, c, !1);
    }
    var nr = rr, ar = tr;
    te.Fragment = n, te.jsx = nr, te.jsxs = ar;
  }()), te;
}
(function(r) {
  process.env.NODE_ENV === "production" ? r.exports = kr() : r.exports = Sr();
})(Ae);
const T = Ae.exports.jsx, _r = Ae.exports.jsxs;
function Pr() {
  var s, l, u;
  const {
    mark: r
  } = wt(), {
    options: e,
    Mark: t
  } = I((f) => ({
    options: f.options,
    Mark: f.Mark
  }), !0);
  mr(r);
  const n = {
    label: r.label,
    value: r.value
  }, i = (u = (l = (s = e[r.childIndex]).initMark) == null ? void 0 : l.call(s, n)) != null ? u : n;
  return /* @__PURE__ */ T(t, {
    ...i
  });
}
class D {
  static get isSelectedPosition() {
    const e = window.getSelection();
    if (!!e)
      return e.isCollapsed;
  }
  static getCurrentPosition() {
    var e, t;
    return (t = (e = window.getSelection()) == null ? void 0 : e.anchorOffset) != null ? t : 0;
  }
  static getFocusedSpan() {
    var e, t, n;
    return (n = (t = (e = window.getSelection()) == null ? void 0 : e.anchorNode) == null ? void 0 : t.textContent) != null ? n : "";
  }
  static getSelectedNode() {
    var t;
    const e = (t = window.getSelection()) == null ? void 0 : t.anchorNode;
    if (e)
      return e;
    throw new Error("Anchor node of selection is not exists!");
  }
  static getAbsolutePosition() {
    var t, n, i;
    const e = (i = (t = window.getSelection()) == null ? void 0 : (n = t.getRangeAt(0)).getBoundingClientRect) == null ? void 0 : i.call(n);
    return e ? {
      left: e.left,
      top: e.top + e.height + 1
    } : {
      left: 0,
      top: 0
    };
  }
  static trySetIndex(e, t) {
    try {
      this.setIndex(e, t);
    } catch (n) {
      console.error(n);
    }
  }
  static setIndex(e, t) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const i = n.getRangeAt(0);
    i == null || i.setStart(e.firstChild || e, t), i == null || i.setEnd(e.firstChild || e, t);
  }
  static getCaretIndex(e) {
    let t = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return t;
    const i = n.getRangeAt(0), s = i.cloneRange();
    return s.selectNodeContents(e), s.setEnd(i.endContainer, i.endOffset), t = s.toString().length, t;
  }
  static setCaretToEnd(e) {
    if (!e)
      return;
    const t = window.getSelection();
    t == null || t.setPosition(e, 1);
  }
  static getIndex() {
    var t;
    const e = window.getSelection();
    return (t = e == null ? void 0 : e.anchorOffset) != null ? t : NaN;
  }
  static setIndex1(e) {
    const t = window.getSelection();
    if (!(t != null && t.anchorNode) || !t.rangeCount)
      return;
    const n = t.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, e), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, e);
  }
  setCaretRightTo(e, t) {
    const n = window.getSelection(), i = n == null ? void 0 : n.getRangeAt(0);
    i == null || i.setStart(i.endContainer, t), i == null || i.setEnd(i.endContainer, t);
  }
}
const Tr = () => {
  const r = Te(NaN);
  return ur(() => {
    Number.isNaN(r.current) || e();
  }), t;
  function e() {
    var i;
    const n = (i = window.getSelection()) == null ? void 0 : i.anchorNode;
    n && D.trySetIndex(n, r.current), r.current = NaN;
  }
  function t(n) {
    r.current = D.getCaretIndex(n);
  }
}, Or = () => {
  const r = wt(), { bus: e } = R(), { style: t, className: n, readOnly: i } = I((k) => ({
    readOnly: k.readOnly,
    style: k.spanStyle,
    className: k.spanClassName
  }), !0), s = Nr(r), [l, u] = re(r.mark.label), [f, h] = re(r.mark.value), g = X((k, O) => {
    O != null && O.silent || (u(k.label), h(k.value)), e.send(w.Change, { key: r.key, value: { ...k } });
  }, []), x = X(() => {
    u(""), h(void 0), e.send(w.Delete, { key: r.key });
  }, []), C = Tr();
  return { label: l, value: f, reg: s, onChange: g, onRemove: x, heldCaret: C, readOnly: i, style: t, className: n };
};
function Nr(r) {
  const e = Te(null);
  return X((t) => {
    if (t && "current" in t) {
      r.ref = t;
      return;
    }
    e.current = t, r.ref = e;
  }, []);
}
const Ar = () => {
  const {
    label: r,
    reg: e,
    onChange: t,
    heldCaret: n,
    className: i,
    style: s,
    readOnly: l
  } = Or();
  return /* @__PURE__ */ T("span", {
    ref: e,
    style: s,
    className: i,
    contentEditable: !l,
    suppressContentEditableWarning: !0,
    onInput: (f) => {
      var g;
      n(f.currentTarget);
      const h = (g = f.currentTarget.textContent) != null ? g : "";
      t({
        label: h
      }, {
        silent: !0
      });
    },
    onPaste: Dr,
    children: r
  });
};
function Dr(r) {
  r.preventDefault();
  const e = r.clipboardData.getData("text");
  document.execCommand("insertText", !1, e);
}
const Ct = mt(() => {
  const r = R(), {
    className: e,
    style: t,
    pieces: n
  } = I((s) => ({
    className: s.className ? lt + " " + s.className : lt,
    style: s.style,
    pieces: s.pieces
  }), !0), i = Oe(() => r.bus.events, []);
  return /* @__PURE__ */ T("div", {
    ref: r.containerRef,
    className: e,
    style: t,
    ...i,
    children: n.toArray().map((s) => /* @__PURE__ */ T(Er, {
      value: s,
      children: xt(s.mark) ? /* @__PURE__ */ T(Pr, {}) : /* @__PURE__ */ T(Ar, {})
    }, s.key))
  });
});
Ct.displayName = "MarkedText";
const Ir = () => {
  const {
    bus: r
  } = R(), e = I((i) => {
    var s;
    return (s = i.onContainer) != null ? s : {};
  }, !0), t = Object.keys(e), n = Object.values(e);
  U(() => {
    const i = [];
    for (let s = 0; s < t.length; s++) {
      let l = t[s], u = n[s];
      i.push(r.listen(l, u));
    }
    return () => i.forEach((s) => s());
  }, n);
};
function jr() {
  const r = R();
  A(w.Change, (e) => {
    const {
      pieces: t,
      onChange: n,
      options: i
    } = r.state, {
      key: s,
      value: l
    } = e, u = t.find((h) => h.key === s);
    u && l && (u.mark.label = l.label, u.mark.value = l.value);
    const f = t.toArray().map((h) => h.mark);
    n(ct(f, i));
  }, []), A(w.Delete, (e) => {
    const {
      pieces: t,
      onChange: n,
      options: i
    } = r.state, {
      key: s
    } = e, l = t.findNode((f) => f.key === s);
    l && l.remove();
    const u = t.toArray().map((f) => f.mark);
    n(ct(u, i));
  }, []), A(w.Select, (e) => {
    var x;
    const {
      pieces: t
    } = r.state, {
      value: n,
      trigger: {
        option: i,
        span: s,
        index: l,
        source: u
      }
    } = e, f = Ne(i.markup, n.label, n.value), h = br(s, f, l, u), g = t.findNode((C) => C.mark.label === s);
    r.recovery = {
      caretPosition: 0,
      prevNodeData: (x = g == null ? void 0 : g.prev) == null ? void 0 : x.data,
      isPrevPrev: !0
    }, g && (g.data.mark.label = h, r.bus.send(w.Change, {
      value: {
        label: h
      },
      key: g.data.key
    }));
  }, []);
}
const Fr = () => {
  const r = R(), { value: e, options: t } = I((s) => ({ value: s.value, options: s.options }), !0), n = Oe(he.split(e, t), [e, t]), i = Te(null);
  U(() => {
    const s = /* @__PURE__ */ new Set(), l = n.map((u) => {
      var g;
      let f = wr(u, s);
      const h = (g = i.current) == null ? void 0 : g.findNode((x) => x.key === f);
      return !h || Lr(u, h) && f++ ? { key: f, mark: ve(u) ? u : { label: u } } : h.data;
    });
    i.current = M.from(l), r.setState({ pieces: i.current });
  }, [n.length]);
}, Lr = (r, e) => ve(r) ? !1 : e.data.mark.label !== r, Mr = (r) => {
  const e = R(), {
    children: t,
    ...n
  } = r;
  U(() => e.setState({
    options: Et(t)
  }), [t]), U(() => e.setState({
    ...n
  }));
}, $r = () => {
  const r = R();
  A("onFocus", (e) => r.focusedNode = r.state.pieces.findNode((t) => {
    var n;
    return ((n = t.ref) == null ? void 0 : n.current) === e.target;
  }), []), A("onBlur", (e) => r.focusedNode = void 0, []);
};
function z(r, e, t = []) {
  A("onKeyDown", (n) => {
    n.key === r && e(n);
  }, t);
}
function Wr() {
  const r = R();
  z($.LEFT, (e) => {
    var i, s, l, u, f;
    if (!pt(e))
      return;
    const t = (i = r.focusedNode) == null ? void 0 : i.prev, n = (f = (s = t == null ? void 0 : t.data.ref) == null ? void 0 : s.current) != null ? f : (u = (l = t == null ? void 0 : t.prev) == null ? void 0 : l.data.ref) == null ? void 0 : u.current;
    n == null || n.focus(), D.setCaretToEnd(n), e.preventDefault();
  }), z($.RIGHT, (e) => {
    var i, s, l, u, f;
    if (!gt(e))
      return;
    const t = (i = r.focusedNode) == null ? void 0 : i.next, n = (f = (s = t == null ? void 0 : t.data.ref) == null ? void 0 : s.current) != null ? f : (u = (l = t == null ? void 0 : t.next) == null ? void 0 : l.data.ref) == null ? void 0 : u.current;
    n == null || n.focus(), e.preventDefault();
  }), z($.DELETE, (e) => {
    var i, s, l, u, f;
    if (!gt(e))
      return;
    const t = (i = r.focusedNode) == null ? void 0 : i.next;
    if (!(t != null && t.data.key))
      return;
    const n = (l = (s = t.prev) == null ? void 0 : s.data.mark.label.length) != null ? l : 0;
    r.recovery = {
      prevNodeData: (f = (u = t.prev) == null ? void 0 : u.prev) == null ? void 0 : f.data,
      caretPosition: n
    }, r.bus.send(w.Delete, {
      key: t.data.key
    }), e.preventDefault();
  }), z($.BACKSPACE, (e) => {
    var i, s, l, u, f;
    if (!pt(e))
      return;
    const t = (i = r.focusedNode) == null ? void 0 : i.prev;
    if (!(t != null && t.data.key))
      return;
    const n = (l = (s = t.prev) == null ? void 0 : s.data.mark.label.length) != null ? l : 0;
    r.recovery = {
      prevNodeData: (f = (u = t.prev) == null ? void 0 : u.prev) == null ? void 0 : f.data,
      caretPosition: n
    }, r.bus.send(w.Delete, {
      key: t.data.key
    }), e.preventDefault();
  });
}
function pt(r) {
  const e = r.target;
  return D.getCaretIndex(e) === 0;
}
function gt(r) {
  var n;
  const e = r.target;
  return D.getCaretIndex(e) === ((n = e.textContent) == null ? void 0 : n.length);
}
const Vr = () => {
  const r = I((e) => e.pieces);
  A("onClick", () => {
    var e, t, n, i;
    r.length === 1 && ((e = r.head) == null ? void 0 : e.data.mark.label) === "" && ((i = (n = (t = r.head) == null ? void 0 : t.data.ref) == null ? void 0 : n.current) == null || i.focus());
  }, [r]);
};
function Ur() {
  const {
    bus: r
  } = R(), e = X(() => r.send(w.CheckTrigger), []);
  A("onFocus", (t) => document.addEventListener("selectionchange", e), []), A("onBlur", (t) => document.removeEventListener("selectionchange", e), []);
}
class De {
  constructor() {
    P(this, "span");
    P(this, "node");
    P(this, "dividedText");
    let e = D.getCurrentPosition();
    this.node = D.getSelectedNode(), this.span = D.getFocusedSpan(), this.dividedText = this.getDividedTextBy(e);
  }
  static find(e) {
    if (D.isSelectedPosition)
      return new De().find(e);
  }
  getDividedTextBy(e) {
    return {
      left: this.span.slice(0, e),
      right: this.span.slice(e)
    };
  }
  find(e) {
    for (let t of e) {
      let n = this.matchInTextVia(t.trigger);
      if (n)
        return {
          value: n.word,
          source: n.annotation,
          index: n.index,
          span: this.span,
          node: this.node,
          option: t
        };
    }
  }
  matchInTextVia(e) {
    const t = this.matchRightPart(), n = this.matchLeftPart(e);
    if (n)
      return {
        word: n.word + t.word,
        annotation: n.annotation + t.word,
        index: n.index
      };
  }
  matchRightPart() {
    var t;
    const {
      right: e
    } = this.dividedText;
    return {
      word: (t = e.match(dr)) == null ? void 0 : t[0]
    };
  }
  matchLeftPart(e) {
    var u;
    const t = this.makeTriggerRegex(e), {
      left: n
    } = this.dividedText, i = n.match(t);
    if (!i)
      return;
    const [s, l] = i;
    return {
      word: l,
      annotation: s,
      index: (u = i.index) != null ? u : 0
    };
  }
  makeTriggerRegex(e) {
    const t = ce(e) + "(\\w*)$";
    return new RegExp(t);
  }
}
const Br = () => {
  const r = R();
  A(w.ClearTrigger, (e) => r.setState({
    trigger: void 0
  }), []), A(w.CheckTrigger, (e) => r.setState({
    trigger: De.find(r.state.options)
  }), []);
};
function zr() {
  const {
    bus: r
  } = R(), e = I((t) => t.trigger);
  U(() => {
    if (!e)
      return;
    const t = (n) => {
      n.key === $.ESC && r.send(w.ClearTrigger);
    };
    return window.addEventListener("keydown", t), () => window.removeEventListener("keydown", t);
  }, [e]);
}
function Gr() {
  const r = R(), e = I((t) => t.trigger);
  U(() => {
    if (!e)
      return;
    const t = (n) => {
      var s, l;
      let i = n.target;
      ((s = r.overlayRef.current) == null ? void 0 : s.contains(i)) || ((l = r.containerRef.current) == null ? void 0 : l.contains(i)) || r.bus.send(w.ClearTrigger);
    };
    return document.addEventListener("click", t), () => document.removeEventListener("click", t);
  }, [e]);
}
const Hr = () => {
  const r = R(), e = I((t) => t.pieces);
  U(() => {
    var t, n, i, s, l, u, f;
    if (r.recovery) {
      const {
        prevNodeData: h,
        caretPosition: g,
        isPrevPrev: x
      } = r.recovery, C = r.state.pieces.findNode((pe) => pe === h), k = x ? (l = (n = (t = C == null ? void 0 : C.next) == null ? void 0 : t.next) == null ? void 0 : n.next) != null ? l : (s = (i = r.state.pieces.head) == null ? void 0 : i.next) == null ? void 0 : s.next : (u = C == null ? void 0 : C.next) != null ? u : r.state.pieces.head, O = (f = k == null ? void 0 : k.data.ref) == null ? void 0 : f.current;
      O == null || O.focus(), O && D.trySetIndex(O, g), r.recovery = void 0;
    }
  }, [e]);
}, qr = ({
  props: r
}) => (Mr(r), Ir(), jr(), Fr(), $r(), Wr(), Vr(), Hr(), Br(), Ur(), zr(), Gr(), null), Yr = cr(({
  trigger: r,
  style: e,
  onSelect: t
}, n) => {
  const [i, s] = re(NaN), l = Oe(() => r.option.data.filter((f) => f.toLowerCase().indexOf(r.value.toLowerCase()) > -1), [r.value]), u = l.length;
  return z($.UP, (f) => {
    f.preventDefault(), s((h) => isNaN(h) ? 0 : (u + (h - 1) % u) % u);
  }, [u]), z($.DOWN, (f) => {
    f.preventDefault(), s((h) => isNaN(h) ? 0 : (h + 1) % u);
  }, [u]), z($.ENTER, (f) => {
    f.preventDefault();
    const h = l[i];
    t({
      label: h,
      value: i.toString()
    });
  }, [l, i]), l.length ? /* @__PURE__ */ T("ul", {
    ref: n,
    className: "mk-suggestions",
    style: e,
    children: l.map((f, h) => {
      const g = h === i ? "mk-suggestion-active" : void 0;
      return /* @__PURE__ */ T("li", {
        ref: (x) => g && (x == null ? void 0 : x.scrollIntoView(!1)),
        className: g,
        onClick: (x) => t({
          label: f,
          value: h.toString()
        }),
        children: f
      }, f);
    })
  }) : null;
});
function Jr(r) {
  var l, u, f;
  const {
    bus: e
  } = R(), t = X(() => e.send(w.ClearTrigger), []), n = X((h) => {
    e.send(w.Select, {
      value: h,
      trigger: r
    }), e.send(w.ClearTrigger);
  }, [r]), i = D.getAbsolutePosition(), s = {
    trigger: r,
    style: i,
    onSelect: n,
    onClose: t
  };
  return (f = (u = (l = r.option).initOverlay) == null ? void 0 : u.call(l, s)) != null ? f : s;
}
const Xr = (r) => {
  const e = R(), t = Jr(r), n = I((i) => {
    var s;
    return (s = i.Overlay) != null ? s : Yr;
  });
  return /* @__PURE__ */ T(n, {
    ref: Cr(n) ? e.overlayRef : void 0,
    ...t
  });
}, Rt = mt(() => {
  const r = I((e) => e.trigger);
  return r ? /* @__PURE__ */ T(Xr, {
    ...r
  }, r.option.index) : null;
});
Rt.displayName = "Whisper";
var de, Y, J, fe;
const Ie = class {
  constructor(...e) {
    K(this, J);
    K(this, de, /* @__PURE__ */ new Map());
    K(this, Y, /* @__PURE__ */ new Map());
    e.forEach((t) => W(this, Y).set(t, /* @__PURE__ */ new Set()));
  }
  get events() {
    let e = {};
    for (let t of W(this, Y).keys())
      e[t] = (n) => this.send(t, n);
    return e;
  }
  static initWithExternalEvents(e) {
    return () => {
      const t = new Set(fr);
      return e && Object.keys(e).filter(dt).forEach((n) => t.add(n)), new Ie(...t);
    };
  }
  send(e, t) {
    le(this, J, fe).call(this, e).forEach((n) => n(t));
  }
  listen(e, t) {
    return le(this, J, fe).call(this, e).add(t), () => le(this, J, fe).call(this, e).delete(t);
  }
};
let Se = Ie;
de = new WeakMap(), Y = new WeakMap(), J = new WeakSet(), fe = function(e) {
  const t = dt(e) ? W(this, Y) : W(this, de);
  return t.has(e) || t.set(e, /* @__PURE__ */ new Set()), t.get(e);
};
var V;
const je = class {
  constructor(e, t) {
    K(this, V, void 0);
    P(this, "focusedNode");
    P(this, "recovery");
    P(this, "containerRef", ot());
    P(this, "overlayRef", ot());
    this.bus = t, ke(this, V, e);
  }
  get state() {
    return W(this, V);
  }
  static create(e) {
    return () => {
      const { children: t, ...n } = e, i = {
        options: Et(t),
        pieces: hr,
        ...n
      }, s = Se.initWithExternalEvents(e.onContainer)();
      return new je(i, s);
    };
  }
  setState(e) {
    ke(this, V, { ...W(this, V), ...e }), this.bus.send(w.State, W(this, V));
  }
};
let _e = je;
V = new WeakMap();
function Zr(r) {
  const [e] = re(_e.create(r));
  return /* @__PURE__ */ _r(xr, {
    value: e,
    children: [/* @__PURE__ */ T(Ct, {}), /* @__PURE__ */ T(Rt, {}), /* @__PURE__ */ T(qr, {
      props: r
    })]
  });
}
const tn = ({
  trigger: r = "@",
  markup: e = "@[__label__](__value__)",
  data: t = [],
  ...n
}) => null;
function rn(r, e, t) {
  const n = Array.isArray(e) ? {
    Mark: r,
    children: e
  } : {
    Mark: r,
    Overlay: e,
    children: t
  };
  return function(s) {
    const l = yt({}, s, n);
    return Zr(l);
  };
}
export {
  Zr as MarkedInput,
  tn as Option,
  Ne as annotate,
  rn as createMarkedInput,
  en as denote,
  Or as useMark
};
//# sourceMappingURL=index.js.map
